const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const price_lists = sequelize.define(
    'price_lists',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

price_list_name: {
        type: DataTypes.TEXT,
      
      

      },

price_list_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"contract",


"promo",


"standard"

        ],

      },

effective_start: {
        type: DataTypes.DATE,
      
      

      },

effective_end: {
        type: DataTypes.DATE,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  price_lists.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





    db.price_lists.hasMany(db.accounts, {
      as: 'accounts_default_price_list',
      foreignKey: {
          name: 'default_price_listId',
      },
      constraints: false,
    });








    db.price_lists.hasMany(db.price_list_items, {
      as: 'price_list_items_price_list',
      foreignKey: {
          name: 'price_listId',
      },
      constraints: false,
    });


    db.price_lists.hasMany(db.account_price_lists, {
      as: 'account_price_lists_price_list',
      foreignKey: {
          name: 'price_listId',
      },
      constraints: false,
    });













//end loop






    db.price_lists.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.price_lists.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return price_lists;
};


